#!/bin/bash

# Version 23/02/2011
# $Revision: 1.14 $
# UDA'Software 2011

# Questo script ha il compito di simulare i multicomandi del mIRC, con
# anche l'inserimento di input da parte dell'utente.

# ________________________________________________________________________________
user_home="$(echo "${HOME}" | tr [:punct:] '_')"
temp_input_utente_file="/tmp/buduscript_script__multicommand_${user_home}.dat"

# ________________________________________________________________________________
if [ "${1}" == "QUERY" ]; then
    query_string=$(echo "${2}" | sed 's@_VIRGOLETTA_@'\''@g')
    position=$(expr 40 + $(expr ${#query_string} / 2) - 1)
    cat<<EOF
********************************************************************************
EOF
    printf "%${position}s\n" "${query_string}"
    cat<<EOF
********************************************************************************
EOF
    read input_utente
    echo "${input_utente}" | sed 's@\\\\@_BUDUS_BACKSLASH_@g' > "${temp_input_utente_file}"
fi

# ________________________________________________________________________________
local_nickname=${1}
local_server=${2}
local_hostname=${3}
command_line=${4}

# ________________________________________________________________________________
command_line=${command_line//\ |\ /_BUDUSCRIPT_SEPARATOR_SEQUENCE_}
command_line=${command_line///_BUDUSCRIPT_ESCAPE_SEQUENCE_}
command_line=${command_line//_BUDUSCRIPT_SEPARATOR_SEQUENCE_/}

IFS_OLD=${IFS}
IFS=''

for command in ${command_line}; do
    command=$(echo "${command//_BUDUSCRIPT_ESCAPE_SEQUENCE_/}" \
	| sed s@[\$]*\?=\\\(_VIRGOLETTE_\\\|\"\\\)${query}\\\(_VIRGOLETTE_\\\|\"\\\)@${answer}@ \
	| sed s/\"/_VIRGOLETTE_/g \
	| sed s/\'/_VIRGOLETTA_/g \
	| sed s/\$nickname/${local_nickname}/g \
	| sed s/\$nick/${local_nickname}/g \
	| sed s/\$server/${local_server}/g \
	| sed s/\$network/${local_hostname}/g )
    
    # Se intercetta un comando di immissione input, provvede ad
    # autoinvocarsi con la richiesta di immissione e a settare
    # opportunamente una variabile d'ambiente.
    max_query=10
    while [ "$(echo "${command}" | grep '[\$]*\$?=_VIRGOLETTE_')" != "" ]; do
	if [ "$(echo "${command}" | grep '[\$]*\$?=_VIRGOLETTE_.*_VIRGOLETTE_')" == "" ] \
	    || [ "$(echo "${command}" | grep '[\$]*\$?=_VIRGOLETTE__VIRGOLETTE_')" != "" ]; then
	    echo '/ECHO ERRORE: Manca il terminatore \" , devo abortire.'
	    exit 1;
	fi
	
	query=$(echo "${command}" \
	    | sed s@[\$]*\$\?=_VIRGOLETTE_@_BUDUSCRIPT_QUERY_@ \
	    | sed s/_VIRGOLETTE_/_BUDUSCRIPT_BREAK_/g \
	    | sed s/.*_BUDUSCRIPT_QUERY_// \
	    | sed s/_BUDUSCRIPT_BREAK_.*//)
	
	if [ "$(xterm -version)" == "" ]; then
	    printf "/ECHO %%C4,1%BERRORE GRAVE:\t%C9,1 xterm non risulta installato nel sistema, devo abortire.\n"
	    exit 1;
	fi
	
	xterm -e ${0} QUERY "${query}"
	answer=$(cat ${temp_input_utente_file} | sed s/@/_BUDUS_CHIOCCIOLA_/g)
	rm -f ${temp_input_utente_file}
	
	command=$(echo "${command}" \
	    | sed 's[\$]*?=_VIRGOLETTE_'${query}'_VIRGOLETTE_'${answer}'g')
	
	max_query=$(expr ${max_query} - 1)
	if [ ${max_query} == 0 ]; then
	    echo "/ECHO ERRORE: Intercettato loop infinito di query, abortisco il comando."
	    
	    exit 1;
	fi
    done
    
    if [ "$(echo "${command}" | grep "[.]\?[tT][iI][mM][eE][rR][ ]*[0-9]*[ ]*[0-9]*")" != "" ]; then
	time_repeat=$(echo "${command}" \
	    | sed s@.*[tT][iI][mM][eE][rR][\ ]*@@ \
	    | cut -f1 -d' ')
	if [ ${time_repeat} -lt 1 ]; then
	    time_repeat=1
	fi
	time_sec=$(echo "${command}" \
	    | sed 's@.*[tT][iI][mM][eE][rR][ ]*[0-9]*[ ]*@@' \
	    | cut -f1 -d' ' \
	    | sed 's/[^0-9]//g')
	if [ ${time_sec:-0} -lt 1 ]; then
	    time_sec=1
	fi
	
	command=$(echo "${command}" \
	    | sed s@[.]\\\?[tT][iI][mM][eE][rR][\ ]*[0-9]*[\ ]*[0-9]*[\ ]*[/]*@TIMER\ -repeat\ ${time_repeat}\ ${time_sec}\ @)
    fi

    find_date=$(echo "${command}" | grep -io '\$date([^)]*)')
    while [ "${find_date}" != "" ]; do
	yyyy=$(date +%Y)
	yy=$(date +%y)
	m=$(date +%m | sed 's@^0@@')
	mm=$(date +%m)
	mmm=$(date +%b)
	mmmm=$(date +%B)
	d=$(date +%d | sed 's@^0@@')
	dd=$(date +%d)
	ddd=$(date +%a)
	dddd=$(date +%A)

	converted_date=$(echo "${find_date}" \
	    | sed "s@\$date(@@" \
	    | sed 's@yyyy@BUDUS_YYYY@g' \
	    | sed 's@yy@BUDUS_YY@g' \
	    | sed 's@mmmm@BUDUS_MMMM@g' \
	    | sed 's@mmm@BUDUS_MMM@g' \
	    | sed 's@mm@BUDUS_MM@g' \
	    | sed 's@m@BUDUS_M@g' \
	    | sed 's@dddd@BUDUS_DDDD@g' \
	    | sed 's@ddd@BUDUS_DDD@g' \
	    | sed 's@dd@BUDUS_DD@g' \
	    | sed 's@d@BUDUS_D@g' \
	    | sed "s@BUDUS_YYYY@${yyyy}@g" \
	    | sed "s@BUDUS_YY@${yy}@g" \
	    | sed "s@BUDUS_MMMM@${mmmm}@g" \
	    | sed "s@BUDUS_MMM@${mmm}@g" \
	    | sed "s@BUDUS_MM@${mm}@g" \
	    | sed "s@BUDUS_M@${m}@g" \
	    | sed "s@BUDUS_DDDD@${dddd}@g" \
	    | sed "s@BUDUS_DDD@${ddd}@g" \
	    | sed "s@BUDUS_DD@${dd}@g" \
	    | sed "s@BUDUS_D@${d}@g" \
	    | sed 's@)@@')
	
	command=$(echo "${command}" | sed "s@\$[Dd][Aa][Tt][Ee]([^)]*)@${converted_date}@g")
	find_date=$(echo "${command}" | grep -io '\$date([^)]*)')
    done
    
    mc_date=$(date +%d/%m/%Y)
    command=$(echo "${command}" | sed "s@\$[Dd][Aa][Tt][Ee]@${mc_date}@g")
    
    find_time=$(echo "${command}" | grep -io '\$time([^)]*)')
    while [ "${find_time}" != "" ]; do
	h=$(date +%H | sed 's@^0@@')
	hh=$(date +%H)
	n=$(date +%M | sed 's@^0@@')
	nn=$(date +%M)
	s=$(date +%S | sed 's@^0@@')
	ss=$(date +%S)

	converted_time=$(echo "${find_time}" \
	    | sed "s@\$time(@@" \
	    | sed 's@hh@BUDUS_HH@g' \
	    | sed 's@h@BUDUS_H@g' \
	    | sed 's@nn@BUDUS_NN@g' \
	    | sed 's@n@BUDUS_N@g' \
	    | sed 's@ss@BUDUS_SS@g' \
	    | sed 's@s@BUDUS_S@g' \
	    | sed "s@BUDUS_HH@${hh}@g" \
	    | sed "s@BUDUS_H@${h}@g" \
	    | sed "s@BUDUS_NN@${nn}@g" \
	    | sed "s@BUDUS_N@${n}@g" \
	    | sed "s@BUDUS_SS@${ss}@g" \
	    | sed "s@BUDUS_S@${s}@g" \
	    | sed 's@)@@')
	
	command=$(echo "${command}" | sed "s@\$[Tt][Ii][Mm][Ee]([^)]*)@${converted_time}@g")
	find_time=$(echo "${command}" | grep -io '\$time([^)]*)')
    done
    
    mc_time=$(date +%H:%M:%S)
    command=$(echo "${command}" | sed "s@\$[Tt][Ii][Mm][Ee]@${mc_time}@g")
    
    echo "/${command}" \
	| sed s@^/[\ ]*@/@ \
	| sed s@//@/@ \
	| sed s/_VIRGOLETTE_/\"/g \
	| sed s/_VIRGOLETTA_/\'/g \
	| sed s/_BUDUS_CHIOCCIOLA_/@/g \
	| sed s/_BUDUS_PIPE_ESCAPE_START_/\\\\\(/g \
	| sed s/_BUDUS_PIPE_ESCAPE_END_/\\\\\)/g \
	| sed s@_BUDUS_BACKSLASH_@\\\\@g \
	| sed 's@_BUDUS_PIPE_PROTECT_OPEN_@\\(@g' \
	| sed 's@_BUDUS_PIPE_PROTECT_CLOSE_@\\)@g' \
	| sed 's@_BUDUS_PIPE_@\|@g' \
	| sed 's@_BUDUS_MC_US_DOLLAR_@$@g'
done

IFS=${IFS_OLD}
# ________________________________________________________________________________